<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="cn.wisenergy.mapper.MemberPercentMapper">
    <resultMap id="userMap" type="cn.wisenergy.model.app.MemberPercent">
        <id column="id" property="id"/>
        <result column="user_level" property="userLevel"/>
        <result column="type" property="type"/>
        <result column="percent" property="percent"/>
        <result column="create_time" property="createTime"/>
        <result column="update_time" property="updateTime"/>
    </resultMap>

    <sql id="table">
        member_percent
    </sql>

    <sql id="cols_all">
        id,
        <include refid="cols_exclude_id"/>
    </sql>

    <sql id="cols_exclude_id">
        user_level,type,percent,create_time,update_time
    </sql>

    <sql id="vals">
        #{userLevel},#{type},#{percent},now(),now()
    </sql>

    <sql id="updateCondition">
        <if test="userLevel != null">user_level = #{userLevel},</if>
        <if test="type != null">type = #{type},</if>
        <if test="percent != null">percent =#{percent},</if>
        update_time =now()
    </sql>

    <sql id="criteria">
        <if test="id != null">id = #{id}</if>
        <if test="userLevel != null">and user_level = #{userLevel}</if>
        <if test="type != null">and type = #{type}</if>
        <if test="percent != null">and percent =#{percent}</if>
        <if test="createTime != null">and create_time &gt;= #{createTime}</if>
        <if test="updateTime != null">and #{updateTime} &gt;= update_time</if>
    </sql>

    <insert id="add" parameterType="cn.wisenergy.model.app.MemberPercent" keyProperty="id" useGeneratedKeys="true">
        insert into
        <include refid="table"/>
        (<include refid="cols_exclude_id"/>)
        value(
        <include refid="vals"/>
        )
    </insert>

    <update id="edit" parameterType="cn.wisenergy.model.app.MemberPercent">
        UPDATE
        <include refid="table"/>
        <set>
            <include refid="updateCondition"/>
        </set>
        <where>
            id = #{id}
        </where>
    </update>

    <delete id="delById" parameterType="java.lang.Integer">
        delete from
        <include refid="table"/>
        where id = #{id}
    </delete>

    <select id="getByLevel" resultType="cn.wisenergy.model.app.MemberPercent">
        select
        <include refid="cols_all"/>
        from
        <include refid="table"/>
        <where>
            user_level=#{userLevel}
        </where>
    </select>

    <select id="getByLevelAndType" resultType="cn.wisenergy.model.app.MemberPercent">
        select
        <include refid="cols_all"/>
        from
        <include refid="table"/>
        <where>
            user_level=#{userLevel}
            and type=#{type}
        </where>
    </select>

</mapper>
